struct Node<T> {
    content: T,
    next: Option<Box<Node<T>>>,
}

fn head_insert<T>(head: Box<Node<T>>, content: T) -> Box<Node<T>> {
    Box::new(Node {
        content,
        next: Some(head),
    })
}

fn pop<T>(head: &mut Option<Box<Node<T>>>) -> Option<T> {
    if let Some(h) = head {
        if h.next.is_some() {
            pop(&mut h.next)
        } else {
            head.take().map(|o| o.content)
        }
    } else {
        None
    }
}

fn main() {
    let head = Box::new(Node {
        content: 2,
        next: None,
    });
    let h = head_insert(head, 1);
    let h = head_insert(h, 0);
    let mut h = Some(h);
    assert_eq!(pop(&mut h), Some(2));
}
