enum MinMaxRes<T> {
    Simple(T),
    Double(T, T),
}

fn minmax<T, I>(mut iter: I) -> Option<MinMaxRes<T>>
where
    I: Iterator<Item = T>,
    T: Ord,
{
    let r: Option<T> = iter.next();
    r.map(|premier| {
        let mut res = MinMaxRes::Simple(premier);
        for e in iter {
            res = match res {
                MinMaxRes::Simple(premier) => {
                    if premier > e {
                        MinMaxRes::Double(e, premier)
                    } else {
                        MinMaxRes::Double(premier, e)
                    }
                }
                MinMaxRes::Double(min, max) => {
                    if e > max {
                        MinMaxRes::Double(min, e)
                    } else if e < min {
                        MinMaxRes::Double(e, max)
                    } else {
                        MinMaxRes::Double(min, max)
                    }
                }
            }
        }
        res
    })
}

fn main() {
    let mut v: Vec<u32> = Vec::new();
    match minmax(v.iter_mut()).unwrap() {
        MinMaxRes::Simple(s) => {
            println!("s: {}", s);
        }
        MinMaxRes::Double(min, max) => {
            *min += 1;
            println!("min: {}, max: {}", min, max);
        }
    }
}
